'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.alertBuilder = exports.alertStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _close = require('react-icons/lib/md/close');

var _close2 = _interopRequireDefault(_close);

var _toggleStyle = require('./utils/toggleStyle');

var _toggleStyle2 = _interopRequireDefault(_toggleStyle);

var _loadAnimation = require('./utils/loadAnimation');

var _loadAnimation2 = _interopRequireDefault(_loadAnimation);

var _template = require('./alert/template');

var _template2 = _interopRequireDefault(_template);

var _builder = require('./alert/builder');

var _builder2 = _interopRequireDefault(_builder);

var _alert = require('./style/alert');

var style = _interopRequireWildcard(_alert);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var alertStyle = exports.alertStyle = style;
var alertBuilder = exports.alertBuilder = _builder2.default;

var Alert = (_temp = _class = function (_React$Component) {
  _inherits(Alert, _React$Component);

  function Alert(props) {
    _classCallCheck(this, Alert);

    var _this = _possibleConstructorReturn(this, (Alert.__proto__ || Object.getPrototypeOf(Alert)).call(this, props));

    var animationStyles = props.animationStyles;

    _this.state = {
      isShown: false,
      component: function component() {
        return _react2.default.createElement('div', null);
      }
    };

    _this.showStyle = (0, _toggleStyle2.default)(true, animationStyles);
    _this.hideStyle = (0, _toggleStyle2.default)(false, animationStyles);

    _this.hide = _this.hide.bind(_this);
    _this.alert = _this.alert.bind(_this);
    return _this;
  }

  _createClass(Alert, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        alert: this.alert,
        hideAlert: this.hide,
        alertIsShown: this.state.isShown
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          props = _objectWithoutProperties(_props, ['children']);

      var _state = this.state,
          isShown = _state.isShown,
          component = _state.component;


      delete props.animationStyles;

      return _react2.default.createElement(
        'div',
        props,
        (0, _loadAnimation2.default)([this.showStyle, this.hideStyle]),
        children,
        _react2.default.createElement(
          _template2.default,
          { isShown: isShown,
            showStyle: this.showStyle,
            hideStyle: this.hideStyle
          },
          component({
            hide: this.hide,
            Icon: function Icon(_ref) {
              var propsStyle = _ref.style,
                  props = _objectWithoutProperties(_ref, ['style']);

              return _react2.default.createElement(_close2.default, _extends({ onClick: _this2.hide
              }, props, {
                style: _extends({}, style.icon, propsStyle)
              }));
            }
          })
        )
      );
    }
  }, {
    key: 'hide',
    value: function hide() {
      var isShown = this.state.isShown;


      if (!isShown) return;

      this.setState({
        isShown: false
      });
    }
  }, {
    key: 'alert',
    value: function alert() {
      var component = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function (_ref2) {
        var Icon = _ref2.Icon;
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(Icon, null)
        );
      };
      var isShown = this.state.isShown;


      if (isShown) return;

      this.setState({
        isShown: true,
        component: component
      });
    }
  }]);

  return Alert;
}(_react2.default.Component), _class.propTypes = {
  children: _propTypes2.default.element.isRequired,
  style: _propTypes2.default.object,
  animationStyles: _propTypes2.default.arrayOf(_propTypes2.default.object.isRequired)
}, _class.defaultProps = {
  animationStyles: [style.hideStyle, style.showStyle]
}, _class.childContextTypes = {
  alert: _propTypes2.default.func.isRequired,
  hideAlert: _propTypes2.default.func.isRequired,
  alertIsShown: _propTypes2.default.bool.isRequired
}, _temp);
exports.default = Alert;