'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _filter = require('./filter');

var _filter2 = _interopRequireDefault(_filter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var getFiles = function getFiles(nowPath, templatePath) {
  return _fs2.default.readdirSync(nowPath).reduce(function (result, file) {
    var childFilePath = _path2.default.resolve(nowPath, file);
    var stats = _fs2.default.lstatSync(childFilePath);

    if (stats.isDirectory()) {
      return [].concat(_toConsumableArray(result), _toConsumableArray(getFiles(childFilePath, templatePath)));
    } else {
      result.push(childFilePath.replace(templatePath + '/', './'));
    }

    return result;
  }, []);
};

exports.default = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(targetPath, templatePath, itemName) {
    var output;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            output = getFiles(_path2.default.resolve(templatePath, itemName), templatePath).reduce(function (result, filePath) {
              return [].concat(_toConsumableArray(result), [{
                target: _path2.default.resolve(targetPath, filePath),
                template: _path2.default.resolve(templatePath, filePath)
              }]);
            }, []);
            _context.next = 3;
            return (0, _filter2.default)(output);

          case 3:
            return _context.abrupt('return', _context.sent);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();