'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _process = require('process');

var _process2 = _interopRequireDefault(_process);

var _nunjucks = require('nunjucks');

var _nunjucks2 = _interopRequireDefault(_nunjucks);

var _htmlMinifier = require('html-minifier');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var root = _process2.default.cwd();
var ENV = _process2.default.env.NODE_ENV === 'production';

var render = function render(component, options, props) {
  _nunjucks2.default.configure(_path2.default.resolve(root, options.root || './views'));
  options.content = (0, _server.renderToStaticMarkup)(_react2.default.createElement(component, props));

  var filename = (options.name === 'index' ? '' : options.name + '/') + 'index.html';
  var output = _nunjucks2.default.render(options.template ? options.template : 'template.html', _extends({}, options, {
    ENV: ENV
  }));

  return {
    filename: filename,
    content: (0, _htmlMinifier.minify)(output, ENV ? /* istanbul ignore next */{
      removeComments: true,
      collapseWhitespace: true,
      minifyCSS: true,
      minifyURLs: true,
      minifyJS: true
    } : {})
  };
};

exports.default = function (config) {
  return config.map(function (_ref) {
    var props = _ref.props,
        options = _objectWithoutProperties(_ref, ['props']);

    var componentPath = _path2.default.resolve(root, options.component);
    options.component = require(componentPath).default || /* istanbul ignore next */require(componentPath);

    return render(options.component, options, props || {});
  });
};