#!/usr/bin/env node

'use strict';

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _process = require('process');

var _process2 = _interopRequireDefault(_process);

var _memFs = require('mem-fs');

var _memFs2 = _interopRequireDefault(_memFs);

var _memFsEditor = require('mem-fs-editor');

var _memFsEditor2 = _interopRequireDefault(_memFsEditor);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _static = require('./core/static');

var _static2 = _interopRequireDefault(_static);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = _process2.default.cwd();

(0, _static2.default)(require(_path2.default.resolve(root, _process2.default.argv[2]))).map(function (_ref) {
  var filename = _ref.filename,
      content = _ref.content;

  var store = _memFs2.default.create();
  var fs = _memFsEditor2.default.create(store);

  fs.write(_path2.default.resolve(root, filename), content);

  fs.commit(function (err) {
    if (err) throw new Error(err);

    console.log(_chalk2.default.green('build ') + _chalk2.default.cyan(filename));
  });
});