'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.calendarTableStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _calendarTable = require('./style/calendarTable');

var style = _interopRequireWildcard(_calendarTable);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var calendarTableStyle = exports.calendarTableStyle = style;

var CalendarTable = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(CalendarTable, _React$Component);

  function CalendarTable(props) {
    _classCallCheck(this, CalendarTable);

    var _this = _possibleConstructorReturn(this, (CalendarTable.__proto__ || Object.getPrototypeOf(CalendarTable)).call(this, props));

    _this.getData = _this.getData.bind(_this);
    return _this;
  }

  _createClass(CalendarTable, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          propsStyle = _props.style,
          props = _objectWithoutProperties(_props, ['children', 'style']);

      delete props.year;
      delete props.month;
      delete props.date;

      return _react2.default.createElement(
        'div',
        _extends({}, props, {
          style: [style.root, propsStyle]
        }),
        this.getData().map(function (d, dIndex) {
          return _react2.default.cloneElement(children, _extends({
            key: dIndex
          }, d));
        })
      );
    }
  }, {
    key: 'getData',
    value: function getData() {
      var _props2 = this.props,
          year = _props2.year,
          month = _props2.month,
          date = _props2.date;

      var defaultTime = { year: year, month: month };
      var defaultDate = (0, _moment2.default)({ year: year, month: month, date: date });
      var end = (0, _moment2.default)(defaultTime).endOf('month').endOf('week').add(1, 'd');
      var output = [];
      var now = (0, _moment2.default)(defaultTime).startOf('week');
      var count = 0;
      var isBefore = true;
      var isAfter = false;

      do {
        output.push({
          year: now.year(),
          month: now.month(),
          date: now.date(),
          isBefore: isBefore,
          isAfter: isAfter,
          sameMonth: now.month() === month
        });

        now = now.add(1, 'd');
        count = count + 1;

        if (!isBefore && !isAfter) isAfter = true;
        if (now.format('YYYY M D') === defaultDate.format('YYYY M D')) isBefore = false;
      } while (now.format('YYYY M D') !== end.format('YYYY M D') && count < 62);

      return output;
    }
  }]);

  return CalendarTable;
}(_react2.default.Component), _class2.propTypes = {
  children: _propTypes2.default.element.isRequired,
  style: _propTypes2.default.object,
  year: _propTypes2.default.number,
  month: _propTypes2.default.number.isRequired,
  date: _propTypes2.default.number
}, _class2.defaultProps = {
  year: (0, _moment2.default)().year(),
  date: (0, _moment2.default)().date()
}, _temp)) || _class;

exports.default = CalendarTable;