'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.calendarStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _areEqual = require('fbjs/lib/areEqual');

var _areEqual2 = _interopRequireDefault(_areEqual);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _calendar = require('./style/calendar');

var style = _interopRequireWildcard(_calendar);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var calendarStyle = exports.calendarStyle = style;

var Calendar = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Calendar, _React$Component);

  function Calendar(props) {
    _classCallCheck(this, Calendar);

    var _this = _possibleConstructorReturn(this, (Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call(this, props));

    var start = props.start,
        end = props.end,
        defaultDate = props.defaultDate;

    var now = (0, _moment2.default)(defaultDate || {});
    _this.state = {
      choices: {
        year: _this.getChoice(end - start + 1, start),
        month: _this.getChoice(12),
        date: _this.getChoice((0, _moment2.default)().endOf('month').date())
      },
      date: {
        year: now.year(),
        month: now.month(),
        date: now.date()
      }
    };

    _this.choose = _this.choose.bind(_this);
    _this.scroll = _this.scroll.bind(_this);
    return _this;
  }

  _createClass(Calendar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.scroll();

      /* istanbul ignore if */
      if (defaultDate) return;

      var _props = this.props,
          getDate = _props.getDate,
          defaultDate = _props.defaultDate;
      var date = this.state.date;


      getDate(date);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var format = nextProps.format,
          date = nextProps.date;

      /* istanbul ignore if */

      if (date && (0, _moment2.default)(date).format(format) !== 'Invalid date' && !(0, _areEqual2.default)(this.state.date, date)) {
        var _state = this.state,
            year = _state.year,
            month = _state.month;

        var choices = _extends({}, this.state.choices);
        var maxDate = (0, _moment2.default)({
          year: date.year || year,
          month: date.month || month
        }).endOf('month').date();

        date.date = date.date > maxDate ? maxDate : date.date;
        choices.date = this.getChoice(maxDate);
        this.setState({
          date: date,
          choices: choices
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _areEqual2.default)(this.state.date, nextState.date);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.props.getDate(this.state.date);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          propsStyle = _props2.style,
          format = _props2.format,
          isChosenStyle = _props2.isChosenStyle,
          props = _objectWithoutProperties(_props2, ['style', 'format', 'isChosenStyle']);

      var _state2 = this.state,
          choices = _state2.choices,
          date = _state2.date;


      delete props.getDate;
      delete props.defaultDate;
      delete props.date;

      return _react2.default.createElement(
        'div',
        _extends({}, props, {
          style: [style.root, propsStyle]
        }),
        _react2.default.createElement(
          'div',
          { style: [style.block, style.textBlock] },
          (0, _moment2.default)(date).format(format)
        ),
        _react2.default.createElement(
          'div',
          { style: style.choiceBlock,
            ref: function ref(node) {
              return _this2.node = node;
            }
          },
          Object.keys(choices).map(function (key, index) {
            return _react2.default.createElement(
              'div',
              { key: index,
                style: style.choice
              },
              choices[key].map(function (data, dataIndex) {
                var value = key === 'month' ? date[key] + 1 : date[key];
                var choiceStyle = data === value ? isChosenStyle : {};

                return _react2.default.createElement(
                  'div',
                  { key: dataIndex,
                    style: choiceStyle,
                    onClick: _this2.choose(key, key === 'month' ? data - 1 : data),
                    id: data === value ? 'is-chosen' : ''
                  },
                  data
                );
              })
            );
          })
        )
      );
    }
  }, {
    key: 'getChoice',
    value: function getChoice(length) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

      return Array.apply({}, { length: length }).map(function (data, index) {
        return index + offset;
      });
    }
  }, {
    key: 'choose',
    value: function choose(key, value) {
      var _this3 = this;

      return function () {
        var date = _extends({}, _this3.state.date);
        var choices = _extends({}, _this3.state.choices);
        date[key] = value;
        var maxDate = (0, _moment2.default)({
          year: date.year,
          month: date.month
        }).endOf('month').date();

        date.date = date.date > maxDate ? maxDate : date.date;
        choices.date = _this3.getChoice(maxDate);
        _this3.setState({ date: date, choices: choices });
      };
    }
  }, {
    key: 'scroll',
    value: function scroll() {
      Array.from(this.node.childNodes).forEach(function (node) {
        var childNode = node.querySelector('#is-chosen');

        node.scrollTop = childNode.offsetTop - node.offsetHeight / 2 + childNode.offsetHeight / 2;
      });
    }
  }]);

  return Calendar;
}(_react2.default.Component), _class2.propTypes = {
  style: _propTypes2.default.object,
  start: _propTypes2.default.number,
  end: _propTypes2.default.number,
  format: _propTypes2.default.string,
  isChosenStyle: _propTypes2.default.object,
  getDate: _propTypes2.default.func,
  date: _propTypes2.default.shape({
    year: _propTypes2.default.number,
    month: _propTypes2.default.number,
    date: _propTypes2.default.number
  }),
  defaultDate: _propTypes2.default.shape({
    year: _propTypes2.default.number,
    month: _propTypes2.default.number,
    date: _propTypes2.default.number
  })
}, _class2.defaultProps = {
  start: 1990,
  end: 2030,
  format: 'MMM D YYYY',
  isChosenStyle: style.isChosenStyle,
  getDate: function getDate() {}
}, _temp)) || _class;

exports.default = Calendar;