'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _eases = require('eases');

var _eases2 = _interopRequireDefault(_eases);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var findTop = function findTop(element) {
  var top = 0;

  do {
    top += element.offsetTop || 0;
    element = element.offsetParent;
  } while (element);

  return top;
};

var goTo = function goTo(main, options) {
  return function (target) {
    var _sec$fps$animation$op = _extends({
      sec: 2,
      fps: 60,
      animation: 'quartInOut'
    }, options),
        sec = _sec$fps$animation$op.sec,
        fps = _sec$fps$animation$op.fps,
        animation = _sec$fps$animation$op.animation;

    var dom = document.querySelector(main);
    var start = dom.scrollTop;
    var end = target ? findTop(document.querySelector(target)) : 0;
    var total = start - end;
    var func = typeof animation === 'string' ? _eases2.default[animation] : animation;
    var count = 0;

    var interval = setInterval(function () {
      var t = 1000 / fps * count / (sec * 1000);
      var nextPosition = total * (1 - func(t)) + end;

      if (total > 0 && nextPosition <= end || total < 0 && nextPosition >= end || total === 0) {
        nextPosition = end;
        clearInterval(interval);
      }

      dom.scrollTop = nextPosition;
      count = count + 1;
    }, 1000 / fps);
  };
};

exports.default = function (main) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (Component) {
    return function (_React$Component) {
      _inherits(GoToAnimation, _React$Component);

      function GoToAnimation() {
        _classCallCheck(this, GoToAnimation);

        return _possibleConstructorReturn(this, (GoToAnimation.__proto__ || Object.getPrototypeOf(GoToAnimation)).apply(this, arguments));
      }

      _createClass(GoToAnimation, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, _extends({}, this.state, this.props, {
            goTo: goTo(main, options)
          }));
        }
      }]);

      return GoToAnimation;
    }(_react2.default.Component);
  };
};