'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.language = undefined;

var _class2, _temp2;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('fetch-everywhere');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var language = exports.language = function language(Component) {
  var _class, _temp;

  return _temp = _class = function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
      _classCallCheck(this, _class);

      return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
    }

    _createClass(_class, [{
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({}, this.state, this.props, this.context));
      } // eslint-disable-line react/display-name

    }]);

    return _class;
  }(_react2.default.Component), _class.contextTypes = {
    translate: _propTypes2.default.object.isRequired,
    changeLanguage: _propTypes2.default.func.isRequired
  }, _temp;
};

var I18n = (_temp2 = _class2 = function (_React$Component2) {
  _inherits(I18n, _React$Component2);

  function I18n(props) {
    _classCallCheck(this, I18n);

    var _this2 = _possibleConstructorReturn(this, (I18n.__proto__ || Object.getPrototypeOf(I18n)).call(this, props));

    var lang = props.lang,
        basename = props.basename,
        defaultData = props.defaultData;

    var state = {
      lang: lang,
      basename: basename
    };

    state[lang] = defaultData;
    _this2.state = state;
    _this2.changeLanguage = _this2.changeLanguage.bind(_this2);
    return _this2;
  }

  _createClass(I18n, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _state = this.state,
          lang = _state.lang,
          data = _objectWithoutProperties(_state, ['lang']);

      return {
        translate: data[lang],
        changeLanguage: this.changeLanguage
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.Children.only(this.props.children);
    }
  }, {
    key: 'changeLanguage',
    value: function changeLanguage(lang) {
      var _this3 = this;

      return function () {
        var _state2 = _this3.state,
            basename = _state2.basename,
            data = _objectWithoutProperties(_state2, ['basename']);

        if (data[lang]) {
          _this3.setState({ lang: lang });
          return;
        }

        /* istanbul ignore next */
        fetch('' + (basename.slice(-1) === '/' ? basename : basename + '/') + lang + '.json').then(function (response) {
          return response.json();
        }).then(function (languageData) {
          data[lang] = languageData;
          _this3.setState(_extends({}, data, {
            lang: lang
          }));
        }).catch(function (e) {
          return console.log('parsing failed', e);
        });
      };
    }
  }]);

  return I18n;
}(_react2.default.Component), _class2.propTypes = {
  lang: _propTypes2.default.string.isRequired,
  defaultData: _propTypes2.default.object.isRequired,
  basename: _propTypes2.default.string,
  children: _propTypes2.default.element.isRequired
}, _class2.defaultProps = {
  basename: '/public/i18n/'
}, _class2.childContextTypes = {
  translate: _propTypes2.default.object.isRequired,
  changeLanguage: _propTypes2.default.func.isRequired
}, _temp2);
exports.default = I18n;