'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.addZoom = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _uuid = require('uuid');

var _uuid2 = _interopRequireDefault(_uuid);

var _eventController = require('./utils/eventController');

var _eventController2 = _interopRequireDefault(_eventController);

var _imgResize = require('./utils/imgResize');

var _imgResize2 = _interopRequireDefault(_imgResize);

var _toggleStyle = require('./utils/toggleStyle');

var _toggleStyle2 = _interopRequireDefault(_toggleStyle);

var _loadAnimation = require('./utils/loadAnimation');

var _loadAnimation2 = _interopRequireDefault(_loadAnimation);

var _img = require('./img');

var _img2 = _interopRequireDefault(_img);

var _imgZoom = require('./style/imgZoom');

var style = _interopRequireWildcard(_imgZoom);

var _add = require('./img-zoom/add');

var _add2 = _interopRequireDefault(_add);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var addZoom = exports.addZoom = _add2.default;

var ImgZoom = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(ImgZoom, _React$Component);

  function ImgZoom(props) {
    _classCallCheck(this, ImgZoom);

    var _this = _possibleConstructorReturn(this, (ImgZoom.__proto__ || Object.getPrototypeOf(ImgZoom)).call(this, props));

    _this.state = {
      src: null,
      isZoom: false,
      addStyle: {},
      imgAnimation: [],
      imgAnimationEnd: true
    };

    _this.zoomIn = _this.zoomIn.bind(_this);
    _this.zoomOut = _this.zoomOut.bind(_this);
    _this.onLoad = _this.onLoad.bind(_this);
    _this.onImgAnimationEnd = _this.onImgAnimationEnd.bind(_this);
    return _this;
  }

  _createClass(ImgZoom, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        zoomIn: this.zoomIn,
        zoomOut: this.zoomOut
      };
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.state.imgAnimationEnd && this.resize) this.resize();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          rootStyle = _props.rootStyle,
          imgBackgroundStyle = _props.imgBackgroundStyle,
          imgStyle = _props.imgStyle,
          props = _objectWithoutProperties(_props, ['children', 'rootStyle', 'imgBackgroundStyle', 'imgStyle']);

      var _state = this.state,
          src = _state.src,
          addStyle = _state.addStyle,
          imgAnimation = _state.imgAnimation,
          imgAnimationEnd = _state.imgAnimationEnd,
          isZoom = _state.isZoom;


      return _react2.default.createElement(
        'div',
        props,
        imgAnimation.length !== 2 ? null : (0, _loadAnimation2.default)([true, false].map(function (bool) {
          return (0, _toggleStyle2.default)(bool, imgAnimation);
        })),
        !src ? null : _react2.default.createElement(
          _radium.StyleRoot,
          { style: [style.root(isZoom), rootStyle(isZoom), addStyle],
            onClick: this.zoomOut
          },
          _react2.default.createElement(
            'div',
            { style: [style.imgBackground, imgBackgroundStyle] },
            _react2.default.createElement(_img2.default, { src: src,
              style: [style.img, imgStyle, imgAnimation.length === 2 && !imgAnimationEnd ? (0, _toggleStyle2.default)(isZoom, imgAnimation) : {}],
              onLoad: this.onLoad,
              onAnimationEnd: this.onImgAnimationEnd
            })
          )
        ),
        children
      );
    }
  }, {
    key: 'zoomIn',
    value: function zoomIn(src, e) {
      var clientRect = e.target.getBoundingClientRect();

      this.setState({
        src: src,
        addStyle: { opacity: '0' },
        imgAnimation: clientRect,
        isZoom: true
      });
    }
  }, {
    key: 'zoomOut',
    value: function zoomOut() {
      this.setState({
        imgAnimationEnd: false,
        isZoom: false
      });
    }
  }, {
    key: 'getStyle',
    value: function getStyle(_ref) {
      var top = _ref.top,
          left = _ref.left,
          width = _ref.width,
          height = _ref.height;

      return {
        position: 'fixed',
        top: top + 'px',
        left: left + 'px',
        width: width + 'px',
        height: height + 'px'
      };
    }
  }, {
    key: 'onLoad',
    value: function onLoad(e) {
      (0, _imgResize2.default)(e.target);
      var clientRect = e.target.getBoundingClientRect();
      var imgAnimation = this.state.imgAnimation;

      var animation = [_extends({}, this.getStyle(imgAnimation)), _extends({}, this.getStyle(clientRect))];

      this.setState({
        addStyle: { opacity: '1' },
        imgAnimation: animation,
        imgAnimationEnd: false
      });
    }
  }, {
    key: 'onImgAnimationEnd',
    value: function onImgAnimationEnd(e) {
      var target = e.target;
      var id = _uuid2.default.v4();

      this.id = id;
      this.resize = function () {
        (0, _imgResize2.default)(target);
      };
      _eventController2.default.addEvent = {
        name: 'resize',
        id: id,
        event: this.resize
      };
      this.setState({ imgAnimationEnd: true });

      var isZoom = this.state.isZoom;


      if (!isZoom) {
        _eventController2.default.removeEvent = {
          name: 'resize',
          id: this.id
        };
        this.setState({
          addStyle: { display: 'none' },
          src: null
        });
      }
    }
  }]);

  return ImgZoom;
}(_react2.default.Component), _class2.propTypes = {
  rootStyle: _propTypes2.default.func,
  imgBackgroundStyle: _propTypes2.default.object,
  imgStyle: _propTypes2.default.object,
  children: _propTypes2.default.element.isRequired
}, _class2.defaultProps = {
  rootStyle: function rootStyle() {}
}, _class2.childContextTypes = {
  zoomIn: _propTypes2.default.func.isRequired,
  zoomOut: _propTypes2.default.func.isRequired
}, _temp)) || _class;

exports.default = ImgZoom;