'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _img = require('./style/img');

var style = _interopRequireWildcard(_img);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Img = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Img, _React$Component);

  function Img(props) {
    _classCallCheck(this, Img);

    var _this = _possibleConstructorReturn(this, (Img.__proto__ || Object.getPrototypeOf(Img)).call(this, props));

    _this.state = {
      src: null
    };

    _this.load = _this.load.bind(_this);
    return _this;
  }

  _createClass(Img, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.load(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.src !== nextProps.src) this.load(nextProps);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unmount = true;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          propsStyle = _props.style,
          type = _props.type,
          link = _props.link,
          target = _props.target,
          props = _objectWithoutProperties(_props, ['style', 'type', 'link', 'target']);

      var src = this.state.src;


      delete props.src;

      if (!src) {
        return _react2.default.createElement(_radium.StyleRoot, _extends({}, props, {
          style: propsStyle
        }));
      }

      var component = type === 'div' ? _react2.default.createElement(_radium.StyleRoot, _extends({}, props, {
        style: [propsStyle, style.div(src)]
      })) : _react2.default.createElement('img', _extends({}, props, {
        style: propsStyle,
        src: src
      }));

      if (link) {
        return _react2.default.createElement(
          'a',
          { href: link,
            target: target ? target : '_self'
          },
          component
        );
      }

      return component;
    }
  }, {
    key: 'load',
    value: function load(props) {
      var _this2 = this;

      var type = props.type,
          src = props.src,
          onLoad = props.onLoad;

      var img = new Image();

      img.onload = function () {
        if (type === 'div') onLoad();

        /* istanbul ignore next */
        if (!_this2.unmount) _this2.setState({ src: src });
      };
      img.src = src;
    }
  }]);

  return Img;
}(_react2.default.Component), _class2.propTypes = {
  style: _propTypes2.default.object,
  type: _propTypes2.default.oneOf(['div', 'img']),
  link: _propTypes2.default.string,
  target: _propTypes2.default.string,
  src: _propTypes2.default.string.isRequired,
  onLoad: _propTypes2.default.func
}, _class2.defaultProps = {
  onLoad: function onLoad() {}
}, _temp)) || _class;

exports.default = Img;