'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.inputStyle = exports.inputCheck = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _input = require('./style/input');

var style = _interopRequireWildcard(_input);

var _check = require('./input/check');

var _check2 = _interopRequireDefault(_check);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var inputCheck = exports.inputCheck = _check2.default;
var inputStyle = exports.inputStyle = style;

var Input = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input(props) {
    _classCallCheck(this, Input);

    var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

    _this.state = {
      value: '',
      isError: false,
      error: []
    };

    _this.validator = _this.validator.bind(_this);
    _this.onChange = _this.validator(_this.props.onChange).bind(_this);
    _this.onBlur = _this.validator(_this.props.onBlur).bind(_this);
    return _this;
  }

  _createClass(Input, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var value = this.props.value;


      this.onChange({
        target: {
          value: value || ''
        }
      });
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      var value = nextProps.value || '';

      if (value !== nextState.value) {
        this.onChange({
          target: {
            value: value
          }
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          propsStyle = _props.style,
          type = _props.type,
          props = _objectWithoutProperties(_props, ['style', 'type']);

      var value = this.state.value;

      var newStyle = [style.input];

      delete props.rules;

      if (type === 'textarea') newStyle.push(style.textarea);

      return _react2.default.createElement(type === 'textarea' ? 'textarea' : 'input', _extends({}, props, {
        type: type,
        style: [style.input, type === 'textarea' ? style.textarea : {}, propsStyle],
        value: value,
        onChange: this.onChange,
        onBlur: this.onBlur
      }));
    }
  }, {
    key: 'validator',
    value: function validator() {
      var _this2 = this;

      var func = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};

      return function (e) {
        var rules = _this2.props.rules;

        var value = e.target.value;
        var output = (0, _check2.default)(value, rules, e);

        func(output, e);
        _this2.setState(output);
      };
    }
  }]);

  return Input;
}(_react2.default.Component), _class2.propTypes = {
  type: _propTypes2.default.string,
  value: _propTypes2.default.string.isRequired,
  style: _propTypes2.default.object,
  onChange: _propTypes2.default.func.isRequired,
  onBlur: _propTypes2.default.func,
  rules: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    validator: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
    message: _propTypes2.default.oneOfType([_propTypes2.default.string.isRequired, _propTypes2.default.func]),
    options: _propTypes2.default.object,
    not: _propTypes2.default.bool
  })).isRequired
}, _temp)) || _class;

exports.default = Input;