'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _validator = require('validator');

var _validator2 = _interopRequireDefault(_validator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (value) {
  var rules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var e = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  var error = [];

  rules.forEach(function (rule) {
    if (typeof rule.validator === 'string') {
      if (rule.not && !_validator2.default[rule.validator](value, rule.options)) error.push(rule.message);else if (!rule.not && _validator2.default[rule.validator](value, rule.options)) error.push(rule.message);
    } else {
      if (rule.validator(value, e)) error.push(rule.message);
    }
  });

  return {
    value: value,
    isError: error.length !== 0,
    error: error
  };
};