'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactRedux = require('react-redux');

var _reducer = require('./reducer');

exports.default = function (formName) {
  return function () {
    var mapStateToProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
    var mapDispatchToProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
    var mergeProps = arguments[2];
    var options = arguments[3];
    return (0, _reactRedux.connect)(function (state, ownProps) {
      var form = {};
      var originForm = state.catForms[formName] || {};
      var isSubmited = originForm.isSubmited;


      Object.keys(originForm).forEach(function (key) {
        if (key === 'isSubmited') return;

        var value = originForm[key];

        form[key] = _extends({}, value, {
          isError: value.value === '' && !isSubmited ? false : value.isError || /* istanbul ignore next */false
        });
      });

      return _extends({}, mapStateToProps(state, ownProps), {
        form: form,
        isSubmited: Boolean(isSubmited)
      });
    }, function (dispatch, ownProps) {
      return _extends({}, mapDispatchToProps(dispatch, ownProps), {
        inputDispatch: function inputDispatch(inputName, value) {
          dispatch((0, _reducer.changeValue)({
            formName: formName,
            inputName: inputName,
            value: value
          }));
        },
        submitDispatch: function submitDispatch(callback) {
          dispatch((0, _reducer.submit)({
            formName: formName,
            callback: callback
          }));
        },
        resetDispatch: function resetDispatch(callback) {
          dispatch((0, _reducer.reset)({
            formName: formName,
            callback: callback
          }));
        }
      });
    }, mergeProps, options);
  };
};