'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var changeValue = exports.changeValue = function changeValue(options) {
  return _extends({}, options, {
    type: 'CAT_INPUT_CHANGE_VALUE'
  });
};

var submit = exports.submit = function submit(options) {
  return _extends({}, options, {
    type: 'CAT_FORM_SUBMIT'
  });
};

var reset = exports.reset = function reset(options) {
  return _extends({}, options, {
    type: 'CAT_FORM_RESET'
  });
};

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _ref = arguments[1];

  var type = _ref.type,
      formName = _ref.formName,
      action = _objectWithoutProperties(_ref, ['type', 'formName']);

  var formRoot = _extends({}, state);
  var form = formRoot[formName] ? _extends({}, formRoot[formName]) : { isSubmited: false };

  switch (type) {
    case 'CAT_INPUT_CHANGE_VALUE':
      {
        var inputName = action.inputName,
            value = action.value;


        form[inputName] = _extends({}, form[inputName], value);
        break;
      }

    case 'CAT_FORM_SUBMIT':
      {
        var callback = action.callback;

        var output = _extends({}, form);
        form.isSubmited = true;

        delete output.isSubmited;

        callback(output);
        break;
      }

    case 'CAT_FORM_RESET':
      {
        var _callback = action.callback;


        _callback(form);
        form.isSubmited = false;

        break;
      }
  }

  if (formName) formRoot[formName] = form;

  return formRoot;
};