'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.loadingStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _d = require('d3');

var d3 = _interopRequireWildcard(_d);

var _eases = require('eases');

var _eases2 = _interopRequireDefault(_eases);

var _loading = require('./style/loading');

var style = _interopRequireWildcard(_loading);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var loadingStyle = exports.loadingStyle = style;

var Loading = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Loading, _React$Component);

  function Loading(props) {
    _classCallCheck(this, Loading);

    var _this = _possibleConstructorReturn(this, (Loading.__proto__ || Object.getPrototypeOf(Loading)).call(this, props));

    var innerRadius = props.innerRadius,
        outerRadius = props.outerRadius;

    _this.state = {
      path: d3.arc().innerRadius(innerRadius).outerRadius(outerRadius),
      start: 0,
      end: 0
    };

    _this.interval = {};
    _this.animation = _this.animation.bind(_this);
    return _this;
  }

  _createClass(Loading, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.animation('start');
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      /* istanbul ignore if */
      if (this.props.innerRadius !== nextProps.innerRadius || this.props.outerRadius !== nextProps.outerRadius) {
        this.setState({
          path: d3.arc().innerRadius(nextProps.innerRadius).outerRadius(nextProps.outerRadius)
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.interval.start);
      clearInterval(this.interval.end);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          outerRadius = _props.outerRadius,
          propsStyle = _props.style,
          props = _objectWithoutProperties(_props, ['outerRadius', 'style']);

      var _state = this.state,
          path = _state.path,
          start = _state.start,
          end = _state.end;


      delete props.innerRadius;
      delete props.fps;
      delete props.sec;
      delete props.diff;
      delete props.animation;

      return _react2.default.createElement(
        _radium.StyleRoot,
        _extends({}, props, {
          style: [style.root(outerRadius), style.animtion, propsStyle]
        }),
        _react2.default.createElement(
          'svg',
          { style: style.root(outerRadius) },
          _react2.default.createElement(
            'g',
            { style: style.g(outerRadius) },
            _react2.default.createElement('path', { d: path.startAngle(start * 2 * Math.PI).endAngle(end * 2 * Math.PI)(),
              style: style.circle
            })
          )
        )
      );
    }
  }, {
    key: 'animation',
    value: function animation(name) {
      var _this2 = this;

      var _props2 = this.props,
          fps = _props2.fps,
          sec = _props2.sec,
          diff = _props2.diff,
          animation = _props2.animation;

      var origin = this.state[name];
      var perTime = 1000 / fps;
      var func = typeof animation === 'string' ? _eases2.default[animation] : /* istanbul ignore next */animation;
      var realyName = name === 'start' ? 'end' : 'start';
      var count = 0;

      this.interval[realyName] = setInterval(function () {
        if (perTime * count > sec * 1000) {
          _this2.animation(realyName);
          clearInterval(_this2.interval[realyName]);
        }

        var output = {};
        var add = diff * func(perTime * count / (sec * 1000));

        output[name] = origin + add;
        count = count + 1;
        _this2.setState(output);
      }, perTime);
    }
  }]);

  return Loading;
}(_react2.default.Component), _class2.propTypes = {
  style: _propTypes2.default.object,
  innerRadius: _propTypes2.default.number,
  outerRadius: _propTypes2.default.number,
  fps: _propTypes2.default.number,
  sec: _propTypes2.default.number,
  diff: _propTypes2.default.number,
  animation: _propTypes2.default.string
}, _class2.defaultProps = {
  innerRadius: 10,
  outerRadius: 13,
  sec: 0.5,
  fps: 60,
  diff: 0.8,
  animation: 'quartInOut'
}, _temp)) || _class;

exports.default = Loading;