'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.menuStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _areEqual = require('fbjs/lib/areEqual');

var _areEqual2 = _interopRequireDefault(_areEqual);

var _toggleStyle = require('./utils/toggleStyle');

var _toggleStyle2 = _interopRequireDefault(_toggleStyle);

var _loadAnimation = require('./utils/loadAnimation');

var _loadAnimation2 = _interopRequireDefault(_loadAnimation);

var _menu = require('./style/menu');

var style = _interopRequireWildcard(_menu);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var menuStyle = exports.menuStyle = style;

var Menu = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Menu, _React$Component);

  function Menu(props) {
    _classCallCheck(this, Menu);

    var _this = _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).call(this, props));

    var animationStyles = props.animationStyles;

    _this.state = {
      isShown: false,
      addStyle: {}
    };

    _this.init = true;
    _this.isEnter = false;
    _this.showStyle = (0, _toggleStyle2.default)(true, animationStyles);
    _this.hideStyle = (0, _toggleStyle2.default)(false, animationStyles);
    _this.toggleMenu = _this.toggleMenu.bind(_this);
    _this.showMenu = _this.showMenu.bind(_this);
    _this.hideMenu = _this.hideMenu.bind(_this);
    _this.hide = _this.hide.bind(_this);
    _this.animationEnd = _this.animationEnd.bind(_this);
    return _this;
  }

  _createClass(Menu, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.props.children !== nextProps.children || this.state.isShown !== nextState.isShown || !(0, _areEqual2.default)(this.state.addStyle, nextState.addStyle);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.interval);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          propsStyle = _props.style,
          menu = _props.menu,
          menuStyle = _props.menuStyle,
          trigger = _props.trigger,
          props = _objectWithoutProperties(_props, ['children', 'style', 'menu', 'menuStyle', 'trigger']);

      var _state = this.state,
          isShown = _state.isShown,
          addStyle = _state.addStyle;

      var newMenuStyle = [style.menu, menuStyle, isShown ? this.showStyle : this.hideStyle, addStyle];

      if (this.init) newMenuStyle.push(style.init);

      delete props.delay;
      delete props.animationStyles;

      return _react2.default.createElement(
        'div',
        _extends({}, props, {
          style: [style.root, propsStyle]
        }),
        _react2.default.cloneElement(children, _extends({}, trigger.includes('click') ? { onClick: this.toggleMenu } : {}, {
          onMouseEnter: this.showMenu,
          onMouseLeave: this.hideMenu
        })),
        (0, _loadAnimation2.default)([this.showStyle, this.hideStyle]),
        _react2.default.createElement(
          _radium.StyleRoot,
          { style: newMenuStyle,
            onAnimationEnd: this.animationEnd,
            onMouseEnter: this.showMenu,
            onMouseLeave: this.hideMenu
          },
          menu({
            hide: this.hide
          })
        )
      );
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.isEnter = false;
      this.setState({ isShown: false });
    }
  }, {
    key: 'toggleMenu',
    value: function toggleMenu() {
      var trigger = this.props.trigger;


      this.init = false;
      if (trigger.includes('hover')) {
        if (!this.isEnter) this.setState({ isShown: !this.state.isShown });
      } else this.setState({ isShown: !this.state.isShown });
    }
  }, {
    key: 'showMenu',
    value: function showMenu() {
      var _this2 = this;

      var trigger = this.props.trigger;


      clearInterval(this.interval);

      this.init = false;
      this.isEnter = true;
      this.interval = setInterval(function () {
        _this2.isEnter = false;
      }, 500);

      if (trigger.includes('hover')) this.setState({ isShown: true });
    }
  }, {
    key: 'hideMenu',
    value: function hideMenu() {
      var _this3 = this;

      var _props2 = this.props,
          trigger = _props2.trigger,
          delay = _props2.delay;


      this.isEnter = false;

      if (trigger.includes('hover')) {
        this.interval = setInterval(function () {
          _this3.setState({ isShown: false });
        }, delay * 1000);
      }
    }
  }, {
    key: 'animationEnd',
    value: function animationEnd(e) {
      var isShown = this.state.isShown;

      this.setState({
        addStyle: isShown ? {} : style.hide
      });
    }
  }]);

  return Menu;
}(_react2.default.Component), _class2.propTypes = {
  children: _propTypes2.default.element.isRequired,
  style: _propTypes2.default.object,
  menu: _propTypes2.default.func.isRequired,
  menuStyle: _propTypes2.default.object,
  delay: _propTypes2.default.number,
  trigger: _propTypes2.default.arrayOf(_propTypes2.default.oneOf(['click', 'hover'])),
  animationStyles: _propTypes2.default.arrayOf(_propTypes2.default.object)
}, _class2.defaultProps = {
  delay: 1,
  trigger: ['click', 'hover'],
  animationStyles: [style.hideStyle, style.showStyle]
}, _temp)) || _class;

exports.default = Menu;