'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.pictureSlideshowStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _loadAnimation = require('./utils/loadAnimation');

var _loadAnimation2 = _interopRequireDefault(_loadAnimation);

var _img = require('./img');

var _img2 = _interopRequireDefault(_img);

var _ImgResize = require('./picture-slideshow/ImgResize');

var _ImgResize2 = _interopRequireDefault(_ImgResize);

var _pictureSlideshow = require('./style/pictureSlideshow');

var style = _interopRequireWildcard(_pictureSlideshow);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var pictureSlideshowStyle = exports.pictureSlideshowStyle = style;

var ImgResizeSlideshow = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(ImgResizeSlideshow, _React$Component);

  function ImgResizeSlideshow(props) {
    _classCallCheck(this, ImgResizeSlideshow);

    var _this = _possibleConstructorReturn(this, (ImgResizeSlideshow.__proto__ || Object.getPrototypeOf(ImgResizeSlideshow)).call(this, props));

    _this.state = {
      index: 0,
      preIndex: 0,
      direction: 'right',
      isAnimation: true
    };

    _this.showStyle = style.showStyle(props.position);
    _this.hideStyle = style.hideStyle(props.position);
    return _this;
  }

  _createClass(ImgResizeSlideshow, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var index = this.props.index;


      this.setState({
        index: index,
        preIndex: -1
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var index = this.props.index;


      if (index !== nextProps.index) {
        this.setState({
          index: nextProps.index,
          preIndex: index,
          direction: nextProps.index > index ? 'left' : 'right'
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return this.props.index !== nextProps.index || this.props.imgs !== nextProps.imgs;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          imgs = _props.imgs,
          type = _props.type,
          propsStyle = _props.style,
          props = _objectWithoutProperties(_props, ['imgs', 'type', 'style']);

      var _state = this.state,
          direction = _state.direction,
          index = _state.index,
          preIndex = _state.preIndex;


      delete props.index;
      delete props.position;

      return _react2.default.createElement(
        _radium.StyleRoot,
        _extends({}, props, {
          style: [style.root, propsStyle]
        }),
        (0, _loadAnimation2.default)([this.hideStyle.left, this.hideStyle.right, this.showStyle.left, this.showStyle.right]),
        imgs.map(function (img, imgIndex) {
          var animation = style.hide;

          if (imgIndex === index) animation = _this2.showStyle[direction];else if (imgIndex === preIndex) animation = _this2.hideStyle[direction];

          if (type === 'img') {
            return _react2.default.createElement(
              _radium.StyleRoot,
              { key: imgIndex,
                style: [style.item, style.imgRoot, img.style, animation]
              },
              _react2.default.createElement(_ImgResize2.default, _extends({}, img, {
                style: style.img,
                type: type
              }))
            );
          }

          return _react2.default.createElement(_img2.default, _extends({ key: imgIndex
          }, img, {
            type: type,
            style: [style.item, img.style, animation]
          }));
        })
      );
    }
  }]);

  return ImgResizeSlideshow;
}(_react2.default.Component), _class2.propTypes = {
  style: _propTypes2.default.object,
  index: _propTypes2.default.number.isRequired,
  imgs: _propTypes2.default.array.isRequired,
  type: _propTypes2.default.oneOf(['img', 'div']),
  position: _propTypes2.default.shape({
    left: _propTypes2.default.object.isRequired,
    center: _propTypes2.default.object.isRequired,
    right: _propTypes2.default.object.isRequired
  })
}, _class2.defaultProps = {
  type: 'div',
  position: style.position
}, _temp)) || _class;

exports.default = ImgResizeSlideshow;