'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.sidebarBuilder = exports.sidebarStyle = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _toggleStyle = require('./utils/toggleStyle');

var _toggleStyle2 = _interopRequireDefault(_toggleStyle);

var _loadAnimation = require('./utils/loadAnimation');

var _loadAnimation2 = _interopRequireDefault(_loadAnimation);

var _template = require('./sidebar/template');

var _template2 = _interopRequireDefault(_template);

var _builder = require('./sidebar/builder');

var _builder2 = _interopRequireDefault(_builder);

var _sidebar = require('./style/sidebar');

var style = _interopRequireWildcard(_sidebar);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var sidebarStyle = exports.sidebarStyle = style;
var sidebarBuilder = exports.sidebarBuilder = _builder2.default;

var Sidebar = (_temp = _class = function (_React$Component) {
  _inherits(Sidebar, _React$Component);

  function Sidebar(props) {
    _classCallCheck(this, Sidebar);

    var _this = _possibleConstructorReturn(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this, props));

    var animationStyles = props.animationStyles;

    _this.state = {
      isShown: false,
      rootStyle: { display: 'none' }
    };

    _this.showStyle = (0, _toggleStyle2.default)(true, animationStyles);
    _this.hideStyle = (0, _toggleStyle2.default)(false, animationStyles);

    _this.hide = _this.hide.bind(_this);
    _this.sidebar = _this.sidebar.bind(_this);
    _this.hideSidebar = _this.hideSidebar.bind(_this);
    return _this;
  }

  _createClass(Sidebar, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        sidebar: this.sidebar,
        hideSidebar: this.hideSidebar
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          menu = _props.menu,
          backgroundStyle = _props.backgroundStyle,
          props = _objectWithoutProperties(_props, ['children', 'menu', 'backgroundStyle']);

      var _state = this.state,
          isShown = _state.isShown,
          rootStyle = _state.rootStyle;


      delete props.animationStyles;
      delete props.rootStyle;

      return _react2.default.createElement(
        'div',
        props,
        (0, _loadAnimation2.default)([this.showStyle, this.hideStyle]),
        children,
        _react2.default.createElement(
          _template2.default,
          { rootStyle: rootStyle,
            isShown: isShown,
            backgroundStyle: backgroundStyle,
            showStyle: this.showStyle,
            hideStyle: this.hideStyle,
            hideSidebar: this.hideSidebar
          },
          menu({ hide: this.hide })
        )
      );
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.setState({
        isShown: false,
        rootStyle: this.props.rootStyle
      });
    }
  }, {
    key: 'sidebar',
    value: function sidebar() {
      if (this.state.isShown) return;

      this.setState({
        isShown: true,
        rootStyle: this.props.rootStyle
      });
    }
  }, {
    key: 'hideSidebar',
    value: function hideSidebar() {
      this.setState({
        isShown: false,
        rootStyle: { display: 'none' }
      });
    }
  }]);

  return Sidebar;
}(_react2.default.Component), _class.propTypes = {
  children: _propTypes2.default.element.isRequired,
  menu: _propTypes2.default.func.isRequired,
  rootStyle: _propTypes2.default.object,
  backgroundStyle: _propTypes2.default.object,
  animationStyles: _propTypes2.default.arrayOf(_propTypes2.default.object.isRequired)
}, _class.defaultProps = {
  animationStyles: [style.hideStyle, style.showStyle]
}, _class.childContextTypes = {
  sidebar: _propTypes2.default.func.isRequired,
  hideSidebar: _propTypes2.default.func.isRequired
}, _temp);
exports.default = Sidebar;