'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.sliderStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _areEqual = require('fbjs/lib/areEqual');

var _areEqual2 = _interopRequireDefault(_areEqual);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _eventController = require('./utils/eventController');

var _eventController2 = _interopRequireDefault(_eventController);

var _slider = require('./style/slider');

var style = _interopRequireWildcard(_slider);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var sliderStyle = exports.sliderStyle = style;

var Slider = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Slider, _React$Component);

  function Slider(props) {
    _classCallCheck(this, Slider);

    var _this = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this, props));

    var value = props.value;

    _this.state = {
      value: value
    };

    _this.findLeft = _this.findLeft.bind(_this);
    _this.click = _this.click.bind(_this);
    _this.dragStart = _this.dragStart.bind(_this);
    _this.setValue = _this.setValue.bind(_this);
    _this.change = _this.change.bind(_this);
    _this.checkValue = _this.checkValue.bind(_this);

    _this.checkValue();
    return _this;
  }

  _createClass(Slider, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      /* istanbul ignore if */
      if (!(0, _areEqual2.default)(this.props.value, nextProps.value)) this.setState({ value: nextProps.value });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state.value !== nextState.value;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.checkValue();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          propsStyle = _props.style,
          max = _props.max,
          min = _props.min,
          buttonStyle = _props.buttonStyle,
          barStyle = _props.barStyle,
          props = _objectWithoutProperties(_props, ['style', 'max', 'min', 'buttonStyle', 'barStyle']);

      var value = this.state.value;

      var percentage = (value - min) / (max - min) * 100;
      var left = 'calc(' + percentage + '% - 10px)';

      delete props.onChange;
      delete props.value;

      return _react2.default.createElement(
        'div',
        _extends({}, props, {
          ref: function ref(node) {
            return _this2.node = node;
          },
          style: [style.root, propsStyle],
          onClick: this.click
        }),
        _react2.default.createElement('div', { style: [style.bar(left), barStyle(percentage / 100)] }),
        _react2.default.createElement('div', { style: [style.button(left), buttonStyle(percentage / 100)],
          onMouseDown: this.dragStart
        })
      );
    }
  }, {
    key: 'findLeft',
    value: function findLeft(element) {
      var left = 0;

      do {
        left += element.offsetLeft || 0;
        element = element.offsetParent;
      } while (element);

      return left;
    }
  }, {
    key: 'click',
    value: function click(e) {
      var _props2 = this.props,
          max = _props2.max,
          min = _props2.min;

      var interval = this.node.offsetWidth || 100;

      this.change((e.pageX - this.findLeft(this.node)) / interval * (max - min), e);
    }
  }, {
    key: 'dragStart',
    value: function dragStart(e) {
      _eventController2.default.addEvent = {
        name: 'mousemove',
        id: 'slider-mousemove',
        event: this.setValue(e.pageX)
      };

      _eventController2.default.addEvent = {
        name: 'mouseup',
        id: 'slider-mouseup',
        event: function event() {
          [{
            name: 'mousemove',
            id: 'slider-mousemove'
          }, {
            name: 'mouseup',
            id: 'slider-mouseup'
          }].forEach(function (data) {
            return _eventController2.default.removeEvent = data;
          });
        }
      };
    }
  }, {
    key: 'setValue',
    value: function setValue(start) {
      var _this3 = this;

      var interval = this.node.offsetWidth || 100;
      var originValue = this.state.value;

      return function (e) {
        var _props3 = _this3.props,
            min = _props3.min,
            max = _props3.max;


        _this3.change((e.pageX - start) / interval * (max - min) + originValue, e);
      };
    }
  }, {
    key: 'change',
    value: function change(originValue, e) {
      var _props4 = this.props,
          min = _props4.min,
          max = _props4.max,
          onChange = _props4.onChange;

      var value = originValue;

      if (value < min) value = min;else if (value > max) value = max;

      onChange(value, e);
      this.setState({ value: value });
    }
  }, {
    key: 'checkValue',
    value: function checkValue() {
      var value = this.state.value;
      var _props5 = this.props,
          min = _props5.min,
          max = _props5.max;


      (0, _invariant2.default)(!(value < min), '"value" should not be smaller then "min".');

      (0, _invariant2.default)(!(max < value), '"value" should not be bigger then "max".');

      (0, _invariant2.default)(!(max === min), '"min" should not be equal to "max".');
    }
  }]);

  return Slider;
}(_react2.default.Component), _class2.propTypes = {
  style: _propTypes2.default.object,
  onChange: _propTypes2.default.func,
  value: _propTypes2.default.number,
  max: _propTypes2.default.number,
  min: _propTypes2.default.number,
  buttonStyle: _propTypes2.default.func,
  barStyle: _propTypes2.default.func
}, _class2.defaultProps = {
  onChange: /* istanbul ignore next */function onChange() {},
  min: 0,
  max: 100,
  value: 0,
  barStyle: function barStyle() {},
  buttonStyle: function buttonStyle() {}
}, _temp)) || _class;

exports.default = Slider;