'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _uuid = require('uuid');

var _uuid2 = _interopRequireDefault(_uuid);

var _eventController = require('./utils/eventController');

var _eventController2 = _interopRequireDefault(_eventController);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Square = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Square, _React$Component);

  function Square(props) {
    _classCallCheck(this, Square);

    var _this = _possibleConstructorReturn(this, (Square.__proto__ || Object.getPrototypeOf(Square)).call(this, props));

    _this.state = {
      height: 'initial'
    };

    _this.resize = _this.resize.bind(_this);
    return _this;
  }

  _createClass(Square, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var id = _uuid2.default.v4();
      var resize = function resize() {
        _this2.resize(_this2.node);
      };

      resize();
      _eventController2.default.addEvent = {
        name: 'resize',
        id: id,
        event: resize
      };
      this.id = id;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _eventController2.default.removeEvent = {
        name: 'resize',
        id: this.id
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var children = this.props.children;
      var height = this.state.height;


      return _react2.default.cloneElement(children, {
        ref: function ref(node) {
          return _this3.node = node;
        },
        style: _extends({
          height: height
        }, children.props.style)
      });
    }
  }, {
    key: 'resize',
    value: function resize(dom) {
      this.setState({ height: dom.offsetWidth + 'px' });
    }
  }]);

  return Square;
}(_react2.default.Component), _class2.propTypes = {
  children: _propTypes2.default.element.isRequired
}, _temp)) || _class;

exports.default = Square;