'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hide = exports.showStyle = exports.hideStyle = exports.position = exports.item = exports.img = exports.imgRoot = exports.root = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _black = require('../color/black');

var _black2 = _interopRequireDefault(_black);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = exports.root = {
  position: 'relative',
  width: '100%',
  height: '80vh',
  margin: '4px 2px',
  overflow: 'hidden',
  background: _black2.default
};

var imgRoot = exports.imgRoot = {
  display: 'flex'
};

var img = exports.img = {
  display: 'block',
  margin: 'auto',
  width: '100%',
  height: 'initial'
};

var item = exports.item = {
  position: 'absolute',
  top: '0px',
  left: '0px',
  width: '100%',
  height: '100%',
  background: _black2.default,
  animation: 'x 0.5s ease-in-out'
};

var position = exports.position = {
  left: {
    opacity: '0',
    transform: 'translateX(-100%)'
  },
  center: {
    opacity: '1',
    transform: 'translateX(0)'
  },
  right: {
    opacity: '0',
    transform: 'translateX(100%)'
  }
};

var hideStyle = exports.hideStyle = function hideStyle(position) {
  return {
    right: _extends({}, position.right, {
      animationName: _radium2.default.keyframes({
        '0%': position.center,
        '100%': position.right
      })
    }),

    left: _extends({}, position.left, {
      animationName: _radium2.default.keyframes({
        '0%': position.center,
        '100%': position.left
      })
    })
  };
};

var showStyle = exports.showStyle = function showStyle(position) {
  return {
    right: _extends({}, position.center, {
      animationName: _radium2.default.keyframes({
        '0%': position.left,
        '100%': position.center
      })
    }),

    left: _extends({}, position.center, {
      animationName: _radium2.default.keyframes({
        '0%': position.right,
        '100%': position.center
      })
    })
  };
};

var hide = exports.hide = {
  display: 'none'
};