'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.init = exports.hide = exports.content = exports.date = exports.bar = exports.circle = exports.svg = exports.root = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _grey = require('../color/grey');

var grey = _interopRequireWildcard(_grey);

var _layout = require('./../layout');

var layoutStyle = _interopRequireWildcard(_layout);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var root = exports.root = _extends({
  margin: '15px 0px',
  display: 'grid',
  gridTemplateColumns: 'calc(50% - 5px) 10px calc(50% - 5px)'
}, layoutStyle.tablet({
  gridTemplateColumns: '0px 10px calc(100% - 10px)'
}));

var svg = exports.svg = {
  width: '10px',
  height: '10px'
};

var circle = exports.circle = function circle(color) {
  return {
    fill: color
  };
};

var bar = exports.bar = function bar(color) {
  return {
    margin: '0px 4px',
    width: '2px',
    height: 'calc(100% - 3px)',
    background: color
  };
};

var date = exports.date = function date(type) {
  return {
    marginTop: '4px',
    padding: type === 'left' ? '0px 15px 0px 0px' : '0px 0px 0px 15px',
    fontSize: '12px',
    textAlign: type === 'left' ? 'right' : 'left'
  };
};

var content = exports.content = function content(type) {
  return {
    margin: type === 'left' ? '18px 15px 20px 0px' : '18px 0px 20px 15px',
    padding: '15px',
    minHeight: '100px',
    border: '1px solid ' + grey._200_
  };
};

var hide = exports.hide = {
  display: 'none'
};

var init = exports.init = {
  display: 'block'
};