'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.switchStyle = exports.icon = exports.root = undefined;

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _blue = require('../color/blue');

var _blue2 = _interopRequireDefault(_blue);

var _lightBlue = require('../color/light-blue');

var _lightBlue2 = _interopRequireDefault(_lightBlue);

var _grey = require('../color/grey');

var grey = _interopRequireWildcard(_grey);

var _style = require('./style');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = exports.root = {
  display: 'inline-block',
  width: '25px',
  height: '25px',
  color: _blue2.default,
  cursor: 'pointer'
};

var icon = exports.icon = {
  width: '100%',
  height: '100%'
};

var switchStyle = exports.switchStyle = function switchStyle(isClicked) {
  return {
    bar: {
      position: 'relative',
      width: '40px',
      height: '10px',
      borderRadius: '20px',
      background: isClicked ? _lightBlue2.default : grey._200_
    },

    button: {
      position: 'absolute',
      top: '-2.5px',
      left: isClicked ? 'calc(100% - 15px)' : '0px',
      width: '15px',
      height: '15px',
      borderRadius: '50%',
      background: isClicked ? _blue2.default : grey._500_,
      boxShadow: _style.boxShadow,
      animation: 'x 0.1s ease-in-out',
      animationName: _radium2.default.keyframes({
        '0%': isClicked ? { left: '0px' } : { left: 'calc(100% - 15px)' },
        '100%': isClicked ? { left: 'calc(100% - 15px)' } : { left: '0px' }
      })
    }
  };
};