'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp, _class3, _class4, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _blue = require('./color/blue');

var _blue2 = _interopRequireDefault(_blue);

var _timeline = require('./style/timeline');

var style = _interopRequireWildcard(_timeline);

var _layout = require('./layout');

var layoutStyle = _interopRequireWildcard(_layout);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Item, _React$Component);

  function Item() {
    _classCallCheck(this, Item);

    return _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).apply(this, arguments));
  }

  _createClass(Item, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          date = _props.date,
          content = _props.content,
          inverted = _props.inverted,
          type = _props.type,
          propsDateStyle = _props.dateStyle;

      var check = inverted ? type !== 'left' : type === 'left';
      var dateStyle = check ? propsDateStyle : style.hide;
      var contentStyle = check ? style.hide : content.props.style || {};
      var tabletStyle = type === 'left' ? style.hide : style.init;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _radium.StyleRoot,
          { style: [style.date(type), dateStyle, layoutStyle.tablet(tabletStyle)]
          },
          date
        ),
        _react2.default.createElement(_radium.StyleRoot, _extends({}, content.props, {
          style: [style.content(type), contentStyle, layoutStyle.tablet(tabletStyle)]
        }))
      );
    }
  }]);

  return Item;
}(_react2.default.Component), _class2.propTypes = {
  date: _propTypes2.default.string.isRequired,
  content: _propTypes2.default.element.isRequired,
  inverted: _propTypes2.default.bool.isRequired,
  type: _propTypes2.default.string.isRequired,
  dateStyle: _propTypes2.default.object
}, _temp)) || _class;

var Timeline = (0, _radium2.default)(_class3 = (_temp2 = _class4 = function (_React$Component2) {
  _inherits(Timeline, _React$Component2);

  function Timeline() {
    _classCallCheck(this, Timeline);

    return _possibleConstructorReturn(this, (Timeline.__proto__ || Object.getPrototypeOf(Timeline)).apply(this, arguments));
  }

  _createClass(Timeline, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          time = _props2.time,
          color = _props2.color,
          props = _objectWithoutProperties(_props2, ['time', 'color']);

      return _react2.default.createElement(
        'div',
        null,
        time.map(function (item, itemIndex) {
          return _react2.default.createElement(
            _radium.StyleRoot,
            { key: itemIndex,
              style: style.root
            },
            _react2.default.createElement(Item, _extends({}, item, props, {
              inverted: Boolean(itemIndex % 2),
              type: 'left'
            })),
            _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                'svg',
                { style: style.svg },
                _react2.default.createElement('circle', { style: style.circle(color),
                  cx: '5',
                  cy: '5',
                  r: '5'
                })
              ),
              _react2.default.createElement('div', { style: style.bar(color) })
            ),
            _react2.default.createElement(Item, _extends({}, item, props, {
              inverted: Boolean(itemIndex % 2),
              type: 'right'
            }))
          );
        })
      );
    }
  }]);

  return Timeline;
}(_react2.default.Component), _class4.propTypes = {
  time: _propTypes2.default.array.isRequired,
  color: _propTypes2.default.string,
  dateStyle: _propTypes2.default.object
}, _class4.defaultProps = {
  color: _blue2.default
}, _temp2)) || _class3;

exports.default = Timeline;