'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (fps) {
  return function (Component) {
    return function (_React$Component) {
      _inherits(Timer, _React$Component);

      function Timer(props) {
        _classCallCheck(this, Timer);

        var _this = _possibleConstructorReturn(this, (Timer.__proto__ || Object.getPrototypeOf(Timer)).call(this, props));

        _this.state = {
          start: null,
          end: null,
          isRunning: false,
          count: 0
        };

        _this.timerStart = _this.timerStart.bind(_this);
        _this.timerStop = _this.timerStop.bind(_this);
        _this.timerReset = _this.timerReset.bind(_this);
        _this.getTime = _this.getTime.bind(_this);
        return _this;
      }

      _createClass(Timer, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          clearInterval(this.interval);
        }
      }, {
        key: 'render',
        value: function render() {
          var _state = this.state,
              isRunning = _state.isRunning,
              state = _objectWithoutProperties(_state, ['isRunning']);

          delete state.start;
          delete state.end;
          delete state.count;

          return _react2.default.createElement(Component, _extends({}, state, this.props, {
            isRunning: isRunning,
            timer: this.getTime(),
            timerStart: this.timerStart,
            timerStop: this.timerStop,
            timerReset: this.timerReset
          }));
        }
      }, {
        key: 'timerStart',
        value: function timerStart() {
          var _this2 = this;

          var time = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _moment2.default)();
          var isRunning = this.state.isRunning;


          if (isRunning) return;

          this.interval = setInterval(function () {
            _this2.setState({ end: (0, _moment2.default)() });
          }, 1000 / fps);

          this.setState({
            start: time,
            end: time,
            isRunning: true
          });
        }
      }, {
        key: 'timerStop',
        value: function timerStop() {
          var _state2 = this.state,
              start = _state2.start,
              count = _state2.count,
              isRunning = _state2.isRunning;

          var end = (0, _moment2.default)();

          if (!isRunning) return;

          clearInterval(this.interval);
          this.setState({
            start: null,
            end: null,
            count: count + (end.format('x') - start.format('x')),
            isRunning: false
          });
        }
      }, {
        key: 'timerReset',
        value: function timerReset() {
          this.setState({
            start: null,
            end: null,
            count: 0,
            isRunning: false
          });
        }
      }, {
        key: 'getTime',
        value: function getTime() {
          var _state3 = this.state,
              start = _state3.start,
              end = _state3.end,
              count = _state3.count;

          var diff = !start || !end ? count : count + (end.format('x') - start.format('x'));
          var diffTime = _moment2.default.duration(diff);

          return {
            hours: diffTime.days() * 24 + diffTime.hours(),
            minutes: diffTime.minutes(),
            seconds: diffTime.seconds(),
            milliseconds: diffTime.milliseconds()
          };
        }
      }]);

      return Timer;
    }(_react2.default.Component);
  };
};