'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.toggleStyle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp, _class3, _class4, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _checkBox = require('react-icons/lib/md/check-box');

var _checkBox2 = _interopRequireDefault(_checkBox);

var _checkBoxOutlineBlank = require('react-icons/lib/md/check-box-outline-blank');

var _checkBoxOutlineBlank2 = _interopRequireDefault(_checkBoxOutlineBlank);

var _radioButtonChecked = require('react-icons/lib/md/radio-button-checked');

var _radioButtonChecked2 = _interopRequireDefault(_radioButtonChecked);

var _radioButtonUnchecked = require('react-icons/lib/md/radio-button-unchecked');

var _radioButtonUnchecked2 = _interopRequireDefault(_radioButtonUnchecked);

var _toggle = require('./style/toggle');

var style = _interopRequireWildcard(_toggle);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var toggleStyle = exports.toggleStyle = style;

var Switch = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Switch, _React$Component);

  function Switch() {
    _classCallCheck(this, Switch);

    return _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).apply(this, arguments));
  }

  _createClass(Switch, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          buttonStyle = _props.buttonStyle,
          isClicked = _props.isClicked,
          props = _objectWithoutProperties(_props, ['buttonStyle', 'isClicked']);

      var newStyle = [style.switchStyle(isClicked).button, buttonStyle(isClicked)];

      return _react2.default.createElement(
        'div',
        props,
        _react2.default.createElement(_radium.StyleRoot, { style: newStyle })
      );
    }
  }]);

  return Switch;
}(_react2.default.Component), _class2.propTypes = {
  isClicked: _propTypes2.default.bool,
  buttonStyle: _propTypes2.default.func
}, _class2.defaultProps = {
  isClicked: false,
  buttonStyle: function buttonStyle() {}
}, _temp)) || _class;

var Toggle = (0, _radium2.default)(_class3 = (_temp2 = _class4 = function (_React$Component2) {
  _inherits(Toggle, _React$Component2);

  function Toggle(props) {
    _classCallCheck(this, Toggle);

    var _this2 = _possibleConstructorReturn(this, (Toggle.__proto__ || Object.getPrototypeOf(Toggle)).call(this, props));

    var type = props.type,
        checked = props.checked,
        clicked = props.clicked;

    _this2.state = {
      isClicked: type === 'checkbox' ? checked : checked || clicked
    };

    if (type === 'radio') {
      (0, _invariant2.default)(!(clicked === undefined), 'If you use "radio", you should use "clicked" to make sure that the value of "radio" will be only one value.');
    }

    _this2.getIcons = _this2.getIcons.bind(_this2);
    _this2.click = _this2.click.bind(_this2);
    return _this2;
  }

  _createClass(Toggle, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.clicked !== nextProps.clicked) this.setState({ isClicked: nextProps.clicked });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state.isClicked !== nextState.isClicked;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          type = _props2.type,
          props = _objectWithoutProperties(_props2, ['type']);

      var isClicked = this.state.isClicked;

      var Icon = this.getIcons(isClicked);
      var iconStyle = _extends({}, style.root, type === 'switch' ? style.switchStyle(isClicked).bar : {}, props.rootStyle(isClicked));

      delete props.rootStyle;
      delete props.clicked;
      delete props.icons;

      return _react2.default.createElement(Icon, _extends({}, props, type !== 'switch' ? {} : { isClicked: isClicked }, {
        style: iconStyle,
        onClick: this.click
      }));
    }
  }, {
    key: 'getIcons',
    value: function getIcons(isClicked) {
      var _props3 = this.props,
          type = _props3.type,
          icons = _props3.icons;


      if (icons) return isClicked ? icons.clicked : icons.default;

      switch (type) {
        case 'radio':
          return isClicked ? _radioButtonChecked2.default : _radioButtonUnchecked2.default;

        case 'switch':
          return Switch;

        default:
          return isClicked ? _checkBox2.default : _checkBoxOutlineBlank2.default;
      }
    }
  }, {
    key: 'click',
    value: function click(e) {
      var onClick = this.props.onClick;
      var isClicked = this.state.isClicked;


      onClick(!isClicked, e);
      this.setState({ isClicked: !isClicked });
    }
  }]);

  return Toggle;
}(_react2.default.Component), _class4.propTypes = {
  checked: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  rootStyle: _propTypes2.default.func,
  type: _propTypes2.default.string,
  clicked: _propTypes2.default.bool,
  icons: _propTypes2.default.shape({
    default: _propTypes2.default.any.isRequired,
    clicked: _propTypes2.default.any.isRequired
  })
}, _class4.defaultProps = {
  rootStyle: function rootStyle() {},
  type: 'checkbox',
  checked: false,
  onClick: function onClick() {}
}, _temp2)) || _class3;

exports.default = Toggle;