'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Controller = function () {
  function Controller() {
    _classCallCheck(this, Controller);

    this.events = {};
  }

  _createClass(Controller, [{
    key: 'runEvent',
    value: function runEvent() {
      var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};

      var events = this.events;
      Object.keys(events).forEach(function (key) {
        window.removeEventListener(key, callback);
        window.addEventListener(key, function (e) {
          var event = events[key];

          Object.keys(event).forEach(function (eventKey) {
            event[eventKey](e);
          });
        });
      });
    }
  }, {
    key: 'addEvent',
    set: function set(data) {
      if (!this.events[data.name]) this.events[data.name] = {};

      if (!this.events[data.name][data.id]) {
        this.events[data.name][data.id] = data.event;
        this.runEvent();
      } else throw new Error('"' + data.id + '" already exists in "' + data.name + '".');
    }
  }, {
    key: 'removeEvent',
    set: function set(data) {
      if (!this.events[data.name]) this.events[data.name] = {};

      if (this.events[data.name][data.id]) {
        delete this.events[data.name][data.id];
        this.runEvent();
      } else throw new Error('"' + data.id + '" does not exist in "' + data.name + '".');
    }
  }, {
    key: 'getEvents',
    get: function get() {
      return this.events;
    }
  }]);

  return Controller;
}();

exports.default = new Controller();