'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function () {
  var status = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
  var styles = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  (0, _invariant2.default)(styles.length >= 2, 'Here are needed at least two styles.');

  var max = styles.length - 1;
  var animations = {};
  var newStyles = status ? [].concat(_toConsumableArray(styles)) : [].concat(_toConsumableArray(styles)).reverse();
  var diff = 100 / max;

  newStyles.forEach(function (style, index) {
    animations[diff * index + 0 + '%'] = style;
  });

  return _extends({}, status ? styles[max] : styles[0], {
    animationName: _radium2.default.keyframes(animations)
  });
};