'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _areEqual = require('fbjs/lib/areEqual');

var _areEqual2 = _interopRequireDefault(_areEqual);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var timeTypes = {
  hour: _propTypes2.default.number,
  minute: _propTypes2.default.number,
  second: _propTypes2.default.number,
  millisecond: _propTypes2.default.number
};

var VideoSubtitle = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(VideoSubtitle, _React$Component);

  function VideoSubtitle(props) {
    _classCallCheck(this, VideoSubtitle);

    var _this = _possibleConstructorReturn(this, (VideoSubtitle.__proto__ || Object.getPrototypeOf(VideoSubtitle)).call(this, props));

    _this.subtitle = _this.sortSubtitle(props.subtitle);
    return _this;
  }

  _createClass(VideoSubtitle, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      /* istanbul ignore if */
      if (!(0, _areEqual2.default)(this.props.subtitle, nextProps.subtitle)) this.subtitle = this.sortSubtitle(nextProps.subtitle);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          now = _props.now,
          props = _objectWithoutProperties(_props, ['now']);

      var nowTime = (0, _moment2.default)(now).format('x');

      delete props.subtitle;

      return _react2.default.createElement(
        'div',
        props,
        this.subtitle.map(function (_ref, index) {
          var content = _ref.content,
              time = _ref.time;
          return _react2.default.cloneElement(content(nowTime === time || nowTime > time && nowTime < (_this2.subtitle[index + 1] || /* istanbul ignore next */{}).time), {
            key: index
          });
        })
      );
    }
  }, {
    key: 'sortSubtitle',
    value: function sortSubtitle(subtitle) {
      return subtitle.map(function (_ref2) {
        var content = _ref2.content,
            time = _objectWithoutProperties(_ref2, ['content']);

        return {
          content: content,
          originTime: time,
          time: (0, _moment2.default)(time).format('x')
        };
      }).sort(function (a, b) {
        return a.time - b.time;
      });
    }
  }]);

  return VideoSubtitle;
}(_react2.default.Component), _class2.propTypes = {
  subtitle: _propTypes2.default.arrayOf(_propTypes2.default.shape(_extends({}, timeTypes, {
    content: _propTypes2.default.func.isRequired
  }))).isRequired,
  now: _propTypes2.default.shape(timeTypes).isRequired
}, _temp)) || _class;

exports.default = VideoSubtitle;