'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = (0, _radium2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(Wrapper, _React$Component);

  function Wrapper(props) {
    _classCallCheck(this, Wrapper);

    var _this = _possibleConstructorReturn(this, (Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call(this, props));

    _this.renderRedux = _this.renderRedux.bind(_this);
    _this.renderRouter = _this.renderRouter.bind(_this);
    return _this;
  }

  _createClass(Wrapper, [{
    key: 'render',
    value: function render() {
      return this.renderRedux(this.renderRouter(_react2.default.Children.only(this.props.children)));
    }
  }, {
    key: 'renderRedux',
    value: function renderRedux(component) {
      if (!this.props.redux) return component;

      var _props$modules = this.props.modules,
          redux = _props$modules.redux,
          reactRedux = _props$modules.reactRedux;
      var createStore = redux.createStore,
          applyMiddleware = redux.applyMiddleware;
      var Provider = reactRedux.Provider;
      var _props$redux = this.props.redux,
          reducer = _props$redux.reducer,
          preloadedState = _props$redux.preloadedState,
          enhancer = _props$redux.enhancer;

      var store = void 0;

      if (preloadedState) {
        if (enhancer) {
          store = createStore(reducer, preloadedState, enhancer instanceof Array ? applyMiddleware.apply(undefined, _toConsumableArray(enhancer)) : applyMiddleware(enhancer));
        } else store = createStore(reducer, preloadedState);
      } else if (enhancer) {
        store = createStore(reducer, enhancer instanceof Array ? applyMiddleware.apply(undefined, _toConsumableArray(enhancer)) : applyMiddleware(enhancer));
      } else store = createStore(reducer);

      return _react2.default.createElement(
        Provider,
        { store: store },
        component
      );
    }
  }, {
    key: 'renderRouter',
    value: function renderRouter(component) {
      if (!this.props.router) return component;

      var reactRouterDom = this.props.modules.reactRouterDom;

      var _props$router = this.props.router,
          isServer = _props$router.isServer,
          routerProps = _objectWithoutProperties(_props$router, ['isServer']);

      var Router = reactRouterDom[isServer ? 'StaticRouter' : 'BrowserRouter'];

      return _react2.default.createElement(
        Router,
        routerProps,
        component
      );
    }
  }]);

  return Wrapper;
}(_react2.default.Component), _class2.propTypes = {
  children: _propTypes2.default.element.isRequired,
  redux: _propTypes2.default.shape({
    reducer: _propTypes2.default.func.isRequired,
    preloadedState: _propTypes2.default.object,
    enhancer: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.arrayOf(_propTypes2.default.func)])
  }),
  router: _propTypes2.default.shape({
    isServer: _propTypes2.default.bool
  }),
  modules: _propTypes2.default.object
}, _temp)) || _class;

exports.default = Wrapper;